#!/usr/bin/perl -w

# I really can't remember what this code does.
#
# Released to the public domain. You may use this
# code any way you wish, private, educational, or commercial.  It's free.

use strict;

my $infile = shift or die "no input file\n";
open(INFILE, "$infile") or die "can't open $infile: $!\n";

my %sizes;
my %count;

my ($usize, $zsize);

while(<INFILE>) {
	if(!/usize/) { next; }

	chomp;

	s/.*usize/usize/;
	s/,//;
	s/[uz]size//g;

	($usize, $zsize) = split;

	if($sizes{$usize}) {
		$sizes{$usize} += $zsize;
		$count{$usize}++;
	} else {
		$sizes{$usize} = $zsize;
		$count{$usize} = 1;
	}
}

close(INFILE);

my ($i, $c, $avg, $t);

$t = 0;
my $tsz = 0;
my $tusz = 0;
printf"usize\t  avg zsize\tavg_ratio(z/u)\tcount\n";
foreach $i (sort {$a <=> $b} keys %sizes) {
	$c = $count{$i};
	$avg = $sizes{$i}/$c;
	$tusz += $c*$i;
	$tsz += $sizes{$i}*$c;
	printf "$i:\t%10.2f\t%10.2f\t%d\n", $avg, $avg/$i, $c;
	$t++;
}
print "got $t different sizes\n";
print "$tsz, $tusz\n";
